<?php

/**
 * Plugin Name: Ecommerce Social Login, Social Sharing by miniOrange
 * Plugin URI: https://www.miniorange.com
 * Description: Allow your users to login, comment and share with Facebook, Google, Apple, Twitter, LinkedIn etc using customizable buttons.
 * Version: 1.0.0
 * Author: miniOrange
 * License URI: http://miniorange.com/usecases/miniOrange_User_Agreement.pdf
 */

define('MO_WC_OPENID_SOCIAL_LOGIN_VERSION', '1.0.0');
define('mo_wc_plugin_url', plugin_dir_url(__FILE__) . "includes/images/icons/");
define('MO_WC_MOSL_PLUGIN_DIR',str_replace('/','\\',plugin_dir_path(__FILE__)));
require('miniorange_wc_openid_sso_settings_page.php');
require('view/config_apps/mo_openid_config_apps_funct.php');
require('class-mo-wc-openid-sso-shortcode-buttons.php');
require('class-mo-wc-openid-social-comment.php');
require('view/email_settings/mo_openid_email_settings_functions.php');
include_once dirname(__FILE__) . '/class-mo-wc-wcOpenid-login-widget.php';

class mo_wc_openid_sso_settings
{
    function __construct()
    {
        register_activation_hook( __FILE__, array( $this, 'mo_wc_openid_activate' ) );
        register_deactivation_hook(__FILE__, array( $this, 'mo_wc_openid_deactivate'));

        add_action('admin_menu', array($this, 'mo_wc_new_miniorange_openid_menu'));
        add_action('init', array( $this, 'mo_wc_openid_plugin_settings_style' ));
        add_action( 'admin_init',  array( $this, 'mo_wc_miniorange_openid_save_settings' ) );
        add_action('init', 'mo_wc_openid_login_validate' );
        add_action( 'plugins_loaded', 'mo_wc_openid_plugin_update' ,1 );
        add_action( 'admin_enqueue_scripts', array( $this, 'mo_wc_openid_plugin_settings_script' ) );
        add_action( 'admin_enqueue_scripts', array( $this, 'mo_wc_openid_plugin_settings_style' ) );
        add_action('wp_ajax_mo-openid-sso-sort-action', 'mo_wc_openid_sso_sort_action');
        add_action('wp_ajax_mo_openid_share', 'mo_wc_openid_share_action');
        add_action('wp_ajax_mo_openid_app_enable', 'mo_wc_openid_sso_enable_app');
        add_action('wp_ajax_mo_openid_app_instructions', 'mo_wc_openid_app_instructions_action');
        add_action('wp_ajax_mo_openid_capp_details', 'mo_wc_openid_capp_details_action');
        add_action('wp_ajax_mo_openid_capp_delete', 'mo_wc_openid_capp_delete');
        add_action('wp_ajax_mo_openid_test_configuration_update', 'mo_wc_openid_test_configuration_update_action');
        add_action('wp_ajax_mo_openid_check_capp_enable', 'mo_wc_openid_check_capp_enable');
        add_action('wp_ajax_mo_sharing_app_value', 'mo_wc_sharing_app_value');
        add_action('wp_ajax_mo_disable_app', 'mo_wc_disable_app');
        add_action( 'wp_enqueue_scripts', array( $this, 'mo_wc_openid_plugin_script' ) ,5);

        //add shortcode
        add_shortcode( 'miniorange_social_login', array($this, 'mo_wc_get_output') );
        add_shortcode( 'miniorange_social_sharing', array($this, 'mo_wc_get_sharing_output') );
        add_shortcode( 'miniorange_social_sharing_vertical', array($this, 'mo_wc_get_vertical_sharing_output') );
        add_filter( 'the_content', array( $this, 'mo_wc_openid_add_social_share_links' ) );
        add_filter( 'the_excerpt', array( $this, 'mo_wc_openid_add_social_share_links' ) );
        add_shortcode( 'miniorange_social_comments', array($this, 'mo_wc_get_comments_output') );

        //set default values
        add_option( 'mo_openid_host_name', 'https://login.xecurify.com');
        update_option('app_pos','facebook#google#vkontakte#twitter#instagram#linkedin#amazon#windowslive#yahoo');
        add_option('mo_openid_default_login_enable',1);
        add_option( 'mo_openid_login_theme', 'longbutton' );
        add_option( 'mo_openid_register_email_message', 'Hello,<br><br>##User Name## has registered to your site  successfully.<br><br>Thanks,<br>miniOrange' );

        add_option( 'mo_login_icon_space','4' );
        add_option( 'mo_login_icon_custom_width','200' );
        add_option( 'mo_login_icon_custom_height','35' );
        add_option( 'mo_login_icon_custom_size','35' );
        add_option( 'mo_login_icon_custom_color', '2B41FF' );
        add_option( 'mo_openid_login_custom_theme', 'default' );
        add_option( 'mo_openid_login_button_customize_text', 'Login with');
        add_option('mo_login_icon_custom_boundary','4');
        add_option( 'mo_openid_login_widget_customize_logout_name_text', 'Howdy, ##username## |' );
        add_option( 'mo_openid_login_widget_customize_logout_text', 'Logout?' );
        add_option('mo_login_openid_login_widget_customize_textcolor','000000');
        add_option( 'mo_openid_login_widget_customize_text', 'Connect with' );
        add_option( 'moopenid_logo_check', 1);
        add_option( 'mo_openid_auto_register_enable', '1');
        add_option( 'mo_openid_logout_redirection_enable', '0' );
        add_option( 'mo_openid_logout_redirect', 'currentpage' );
        add_option( 'mo_openid_register_disabled_message', 'Registration is disabled for this website. Please contact the administrator for any queries.' );
        add_option('mo_openid_login_role_mapping','subscriber');
        add_option( 'moopenid_social_login_avatar','1' );
        add_option( 'mo_openid_login_redirect', 'homepage' );
        add_option( 'mo_openid_email_enable', '1');

        //social sharing
        add_option( 'mo_openid_share_theme', 'oval' );
        add_option( 'mo_openid_share_custom_theme', 'default' );
        add_option( 'mo_share_icon_space','4' );
        add_option('mo_sharing_icon_custom_color','000000');
        add_option('mo_sharing_icon_custom_font','000000');
        add_option( 'mo_share_icon_custom_height','35' );
        add_option( 'mo_sharing_icon_space','4' );
        add_option('mo_share_icon_custom_boundary','4');
        add_option( 'mo_openid_share_widget_customize_text_color', '000000');
        add_option( 'mo_openid_share_widget_customize_text', 'Share with:' );
        add_option( 'mo_openid_share_email_subject','I wanted you to see this site' );
        add_option('share_app','facebook#twitter#google#vkontakte#tumblr#stumble#linkedin#reddit#pinterest#pocket#digg#delicious#odnoklassniki#mail#print#whatsapp');
        add_option('mo_sharing_icon_custom_size','35');
        add_option('mo_openid_share_email_body','Check out this site ##url##');

        add_option( 'mo_share_options_enable_post_position', 'before');
        add_option( 'mo_share_options_home_page_position', 'before');
        add_option( 'mo_share_options_static_pages_position', 'before');
        add_option( 'mo_share_options_bb_forum_position', 'before');
        add_option( 'mo_share_options_bb_topic_position', 'before');
        add_option( 'mo_share_options_bb_reply_position', 'before');


        //Social Commenting
        add_option( 'mo_openid_social_comment_blogpost','1' );
        add_option( 'mo_openid_social_comment_default_label', 'Default Comments' );
        add_option( 'mo_openid_social_comment_fb_label', 'Facebook Comments' );
        add_option( 'mo_openid_social_comment_disqus_label', 'Disqus Comments' );
        add_option( 'mo_disqus_shortname', '' );
        add_option( 'mo_openid_social_comment_heading_label', 'Leave a Reply' );
        add_option( 'mo_openid_login_theme', 'default' );
        add_option( 'mo_openid_woocommerce_before_login_form','1');
        add_option( 'mo_openid_woocommerce_register_form_start','1');



        if(get_option('mo_openid_woocommerce_register_form_start') == 1){
            add_action( 'woocommerce_register_form_start', array($this, 'mo_wc_openid_add_social_login'));
        }

        if(get_option('mo_openid_woocommerce_before_login_form') == 1){
            add_action( 'woocommerce_login_form_start', array($this, 'mo_wc_openid_add_social_login'));
        }
        if(get_option('mo_openid_default_comment_enable') == 1 ){
            add_action('comment_form_must_log_in_after', array($this, 'mo_wc_openid_add_social_login'));
            add_action('comment_form_top', array($this, 'mo_wc_openid_add_social_login'));
        }
        if(get_option('mo_openid_social_comment_fb') == 1 || get_option('mo_openid_social_comment_disqus') == 1 ){
            add_action('comment_form_top', array( $this, 'mo_wc_openid_add_comment'));
        }

        // add social login icons to default login form
        if(get_option('mo_openid_default_login_enable') == 1) {
            add_action('login_form', array($this, 'mo_wc_openid_add_social_login'));
            if (strpos($_SERVER["REQUEST_URI"], "mo_wc_openid_general_settings") > 0) {
                add_action('login_enqueue_scripts', array($this, 'mo_wc_custom_login_stylesheet'));
            }
        }

        // add social login icons to default registration form
        if(get_option('mo_openid_default_register_enable') == 1){
            add_action( 'register_form', array($this, 'mo_wc_openid_add_social_login') );
        }

        // add social login icons to comment form
        if(get_option('mo_openid_default_comment_enable') == 1 ){
            add_action('comment_form_must_log_in_after', array($this, 'mo_wc_openid_add_social_login'));
            add_action('comment_form_top', array($this, 'mo_wc_openid_add_social_login'));
        }

        //custom avatar
        if(get_option('moopenid_social_login_avatar')) {
            add_filter( 'get_avatar', array( $this, 'mo_wc_social_login_custom_avatar' ), 15, 5 );
            add_filter( 'get_avatar_url', array( $this, 'mo_wc_social_login_custom_avatar_url' ), 15, 3);
        }

        //Error messages options
        add_option( 'mo_registration_error_message','There was an error in registration. Please contact your administrator.');
        add_option( 'mo_email_failure_message','Either your SMTP is not configured or you have entered an unmailable email. Please go back and try again.');
        add_option( 'mo_existing_username_error_message','This username already exists. Please ask the administrator to create your account with a unique username.');
        add_option( 'mo_manual_login_error_message','There was an error during login. Please try to login/register manually. <a href='.site_url().'>Go back to site</a>');
        add_option( 'mo_delete_user_error_message','Error deleting user from account linking table');
        $message='Dear User,
        
Your verification code for completing your profile is: ##otp##  Please use this code to complete your profile.
         
Do not share this code with anyone.
        
Thank you.';

        add_option( 'custom_otp_msg',$message);
    }

    function mo_wc_openid_plugin_settings_script() {
        wp_enqueue_script( 'mo_openid_admin_settings_phone_script', plugins_url('includes/js/phone.js', __FILE__ ));
        wp_enqueue_script( 'mo_openid_admin_settings_script', plugins_url('includes/js/settings.js?version=4.9.6', __FILE__ ), array('jquery'));
        wp_enqueue_script( 'mo_openid_admin_settings_phone_script', plugins_url('includes/js/bootstrap.min.js', __FILE__ ));
    }

    function mo_wc_openid_plugin_settings_style() {
        wp_enqueue_style( 'mo_openid_admin_settings_style', plugins_url('includes/css/mo_openid_style.css?version=7.3.0', __FILE__));
        wp_enqueue_style( 'mo_openid_admin_settings_phone_style', plugins_url('includes/css/phone.css', __FILE__));
        wp_enqueue_style( 'mo-wp-bootstrap-social',plugins_url('includes/css/bootstrap-social.css', __FILE__), false );
        wp_enqueue_style( 'mo-wp-bootstrap-main',plugins_url('includes/css/bootstrap.min-preview.css', __FILE__), false );
        wp_enqueue_style( 'mo-openid-sl-wp-font-awesome',plugins_url('includes/css/mo-font-awesome.min.css', __FILE__), false );
        wp_enqueue_style( 'mo-openid-sl-wp-font-awesome',plugins_url('includes/css/mo-font-awesome.css', __FILE__), false );
    }

    function mo_wc_openid_activate() {
        add_option('mo_openid_malform_error', '1');
        add_option('Activated_Plugin','Plugin-Slug');
        update_option( 'mo_openid_host_name', 'https://login.xecurify.com');
    }

    function mo_wc_new_miniorange_openid_menu() {
        //Add miniOrange plugin to the menu
        $page = add_menu_page( 'MO OpenID Settings ' . __( 'Configure OpenID', 'mo_wc_openid_settings' ), 'Ecommerce Social Login', 'administrator',
            'mo_wc_openid_settings', 'mo_wc_register_openid' ,plugin_dir_url(__FILE__) . 'includes/images/miniorange_icon.png');
        $page = add_submenu_page( 'mo_wc_openid_settings', 'MiniOrange-General Settings','Social Login', 'administrator','mo_wc_openid_general_settings','mo_wc_register_openid' );
        $page = add_submenu_page( 'mo_wc_openid_settings', 'MiniOrange-General Settings','Social Sharing', 'administrator','mo_wc_openid_social_sharing_settings','mo_wc_register_sharing_openid' );
        $page = add_submenu_page( 'mo_wc_openid_settings', 'MiniOrange-General Settings','Social Commenting', 'administrator','mo_wc_openid_social_commenting_settings','mo_wc_comment_openid');
        remove_submenu_page('mo_wc_openid_settings','mo_wc_openid_settings');
    }

    function mo_wc_custom_login_stylesheet()
    {
        wp_enqueue_style( 'mo-wp-style',plugins_url('includes/css/mo_openid_style.css?version=7.3.0', __FILE__), false );
        wp_enqueue_style( 'mo-wp-bootstrap-social',plugins_url('includes/css/bootstrap-social.css', __FILE__), false );
        wp_enqueue_style( 'mo-wp-bootstrap-main',plugins_url('includes/css/bootstrap.min.css', __FILE__), false );
        wp_enqueue_style( 'mo-openid-sl-wp-font-awesome',plugins_url('includes/css/mo-font-awesome.min.css', __FILE__), false );
        wp_enqueue_style( 'mo-openid-sl-wp-font-awesome',plugins_url('includes/css/mo-font-awesome.css', __FILE__), false );

    }

    function mo_wc_openid_add_social_login(){
        if(!is_user_logged_in() && strpos( $_SERVER['QUERY_STRING'], 'disable-social-login' ) == false){
            $mo_login_widget = new mo_wc_openid_login_wid();
            $mo_login_widget->mo_wc_openidloginForm();
        }
    }

    function mo_wc_openid_add_comment(){
        global $post;
        if(isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off'){
            $http = "https://";
        } else {
            $http = "http://";
        }
        $url = $http . $_SERVER["HTTP_HOST"] . $_SERVER['REQUEST_URI'];
        if(is_single() && get_option('mo_openid_social_comment_blogpost') == 1 ) {
            mo_wc_openid_social_comment($post, $url);
        } else if(is_page() && get_option('mo_openid_social_comment_static')==1) {
            mo_wc_openid_social_comment($post, $url);
        }
    }

    function mo_wc_openid_plugin_script() {
        wp_enqueue_script( 'mo-social-login-script',plugins_url('includes/js/social_login.js', __FILE__), array('jquery') );
    }

    function mo_wc_miniorange_openid_save_settings()
    {
        if(is_admin() && get_option('Activated_Plugin')=='Plugin-Slug') {
            delete_option('Activated_Plugin');
            update_option('mo_openid_message','Go to plugin <b><a href="admin.php?page=mo_wc_openid_settings">settings</a></b> to enable Ecommerce Social Login, Social Sharing by miniOrange.');
            add_action('admin_notices', 'mo_wc_openid_activation_message');
        }

        $value = isset( $_POST['option']) ? sanitize_text_field($_POST['option']): '';
        switch( $value )
        {
            case 'mo_openid_customise_social_icons':
                $nonce = sanitize_text_field($_POST['mo_openid_customise_social_icons_nonce']);
                if (!wp_verify_nonce($nonce, 'mo-openid-customise-social-icons-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }
                else{
                    update_option('mo_openid_login_theme',isset($_POST['mo_openid_login_theme'])? sanitize_text_field($_POST['mo_openid_login_theme']):"");
                    update_option('mo_openid_login_custom_theme',isset($_POST['mo_openid_login_custom_theme'])? sanitize_text_field($_POST['mo_openid_login_custom_theme']):"");
                    update_option('mo_login_icon_custom_color',isset($_POST['mo_login_icon_custom_color'])? sanitize_text_field($_POST['mo_login_icon_custom_color']):"");
                    update_option('mo_login_icon_space',isset($_POST['mo_login_icon_space'])? sanitize_text_field($_POST['mo_login_icon_space']):"");
                    update_option('mo_login_icon_custom_width', isset($_POST['mo_login_icon_custom_width'])?sanitize_text_field($_POST['mo_login_icon_custom_width']):"");
                    update_option('mo_login_icon_custom_height',isset($_POST['mo_login_icon_custom_height'])? sanitize_text_field($_POST['mo_login_icon_custom_height']):"");
                    update_option('mo_login_icon_custom_boundary',isset($_POST['mo_login_icon_custom_boundary'])? sanitize_text_field($_POST['mo_login_icon_custom_boundary']):"");
                    update_option('mo_login_icon_custom_size',isset($_POST['mo_login_icon_custom_size'])? sanitize_text_field($_POST['mo_login_icon_custom_size']):"");
                    update_option('mo_login_openid_login_widget_customize_textcolor',isset($_POST['mo_login_openid_login_widget_customize_textcolor'])? sanitize_text_field($_POST['mo_login_openid_login_widget_customize_textcolor']):"");
                    update_option('mo_openid_login_widget_customize_text',isset($_POST['mo_openid_login_widget_customize_text'])? sanitize_text_field($_POST['mo_openid_login_widget_customize_text']):"");
                    update_option('mo_openid_login_button_customize_text',isset($_POST['mo_openid_login_button_customize_text'])? sanitize_text_field($_POST['mo_openid_login_button_customize_text']):"");
                    update_option('mo_openid_login_widget_customize_logout_name_text',isset($_POST['mo_openid_login_widget_customize_logout_name_text'])? sanitize_text_field($_POST['mo_openid_login_widget_customize_logout_name_text']):"");
                    update_option('mo_openid_login_widget_customize_logout_text', isset($_POST['mo_openid_login_widget_customize_logout_text'])?sanitize_text_field($_POST['mo_openid_login_widget_customize_logout_text']):"");
                    update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_enable_redirect':
                $nonce=sanitize_text_field($_POST['mo_openid_enable_redirect_nonce']);
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-redirect-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }else {
                    //Redirect URL
                    update_option('mo_openid_login_redirect', isset($_POST['mo_openid_login_redirect'])?sanitize_text_field($_POST['mo_openid_login_redirect']):"");
                    update_option('mo_openid_login_redirect_url', isset($_POST['mo_openid_login_redirect_url'])?sanitize_text_field($_POST['mo_openid_login_redirect_url']):"");
                    update_option('mo_openid_relative_login_redirect_url', isset($_POST['mo_openid_relative_login_redirect_url']) ? sanitize_text_field($_POST['mo_openid_relative_login_redirect_url']) : "");

                    //Logout Url
                    update_option('mo_openid_logout_redirection_enable', isset($_POST['mo_openid_logout_redirection_enable']) ? sanitize_text_field($_POST['mo_openid_logout_redirection_enable']) : 0);
                    update_option('mo_openid_logout_redirect', isset($_POST['mo_openid_logout_redirect'])? sanitize_text_field($_POST['mo_openid_logout_redirect']) : '');
                    update_option('mo_openid_logout_redirect_url',isset($_POST['mo_openid_logout_redirect_url'])?sanitize_text_field($_POST['mo_openid_logout_redirect_url']):"");
                    update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_enable_registration':
                $nonce=sanitize_text_field($_POST['mo_openid_enable_registration_nonce']);
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-registration-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }else {
                    update_option('mo_openid_auto_register_enable', isset($_POST['mo_openid_auto_register_enable']) ? sanitize_text_field($_POST['mo_openid_auto_register_enable']) : 0);
                    update_option('mo_openid_register_disabled_message',isset($_POST['mo_openid_register_disabled_message'])? sanitize_text_field($_POST['mo_openid_register_disabled_message']):"");
                    update_option('mo_openid_login_role_mapping', isset($_POST['mapping_value_default']) ? sanitize_text_field($_POST['mapping_value_default']) : 'subscriber');
	                update_option('mo_openid_message', 'Your settings are saved successfully.');
                    update_option( 'mo_openid_email_enable', isset( $_POST['mo_openid_email_enable']) ? sanitize_text_field($_POST['mo_openid_email_enable']) : 0);
                    update_option( 'moopenid_social_login_avatar', isset( $_POST['moopenid_social_login_avatar']) ? sanitize_text_field($_POST['moopenid_social_login_avatar']) : 0);
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_enable_display':
                $nonce=sanitize_text_field($_POST['mo_openid_enable_display_nonce']);
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-display-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }else {
                    update_option('mo_openid_default_login_enable', isset($_POST['mo_openid_default_login_enable']) ? sanitize_text_field($_POST['mo_openid_default_login_enable']) : 0);
                    update_option('mo_openid_default_register_enable', isset($_POST['mo_openid_default_register_enable']) ? sanitize_text_field($_POST['mo_openid_default_register_enable']) : 0);
                    update_option('mo_openid_default_comment_enable', isset($_POST['mo_openid_default_comment_enable']) ? sanitize_text_field($_POST['mo_openid_default_comment_enable']) : 0);
                    update_option('moopenid_logo_check', isset($_POST['moopenid_logo_check']) ? sanitize_text_field($_POST['moopenid_logo_check']) : 0);
                    update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_enable_woocommerce_display':
                $nonce=sanitize_text_field($_POST['mo_openid_enable_woocommerce_display_nonce']);
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-woocommerce-display-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }else {
                    update_option('mo_openid_woocommerce_before_login_form', isset($_POST['mo_openid_woocommerce_before_login_form']) ? sanitize_text_field($_POST['mo_openid_woocommerce_before_login_form']) : 0);
                    update_option('mo_openid_woocommerce_register_form_start', isset($_POST['mo_openid_woocommerce_register_form_start']) ? sanitize_text_field($_POST['mo_openid_woocommerce_register_form_start']) : 0);
                    update_option('mo_openid_message', 'Your settings are saved successfully.');
                    mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_enable_customize_text':
                $nonce=sanitize_text_field($_POST['mo_openid_enable_customize_text_nonce']);
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-customize-text-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }else {
                    update_option('mo_sharing_icon_custom_size',isset($_POST['mo_sharing_icon_custom_size'])?sanitize_text_field($_POST['mo_sharing_icon_custom_size']):0);
                    update_option('mo_sharing_icon_space',isset($_POST['mo_sharing_icon_space'])? sanitize_text_field($_POST['mo_sharing_icon_space']):0);
                    update_option('mo_sharing_icon_custom_font',isset($_POST['mo_sharing_icon_custom_font'])? sanitize_text_field($_POST['mo_sharing_icon_custom_font']):0);
                    update_option('mo_sharing_icon_custom_color',isset($_POST['mo_sharing_icon_custom_color'])?sanitize_text_field($_POST['mo_sharing_icon_custom_color']):000000);
                    update_option('mo_openid_share_custom_theme',isset($_POST['mo_openid_share_custom_theme'])?sanitize_text_field($_POST['mo_openid_share_custom_theme']):"");
                    update_option('mo_openid_share_theme',isset($_POST['mo_openid_share_theme'])?sanitize_text_field($_POST['mo_openid_share_theme']):"");
                    update_option('mo_openid_login_widget_customize_text',isset($_POST['mo_openid_login_widget_customize_text'])? sanitize_text_field($_POST['mo_openid_login_widget_customize_text']):"");
                    update_option('mo_openid_login_button_customize_text',isset($_POST['mo_openid_login_button_customize_text'])? sanitize_text_field($_POST['mo_openid_login_button_customize_text']):"");
                    update_option('mo_openid_share_widget_customize_text', isset($_POST['mo_openid_share_widget_customize_text'])?sanitize_text_field($_POST['mo_openid_share_widget_customize_text']):"");
                    update_option('mo_openid_share_widget_customize_text_color',isset($_POST['mo_openid_share_widget_customize_text_color'])? sanitize_text_field($_POST['mo_openid_share_widget_customize_text_color']):000000);
                    update_option('mo_openid_share_twitter_username',isset($_POST['mo_openid_share_twitter_username'])? sanitize_text_field($_POST['mo_openid_share_twitter_username']):"");
                    update_option('mo_openid_share_email_subject',isset($_POST['mo_openid_share_email_subject'])? sanitize_text_field($_POST['mo_openid_share_email_subject']):"");
                    update_option('mo_openid_share_email_body',isset($_POST['mo_openid_share_email_body'])? sanitize_text_field($_POST['mo_openid_share_email_body']):"");
	                update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_enable_share_display':
                $nonce=$_POST['mo_openid_enable_share_display_nonce'];
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-share-display-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }
                else{
                    update_option('mo_share_options_enable_home_page', isset($_POST['mo_share_options_home_page']) ? sanitize_text_field($_POST['mo_share_options_home_page']) : 0);
                    update_option('mo_share_options_enable_post', isset($_POST['mo_share_options_post']) ? sanitize_text_field($_POST['mo_share_options_post']) : 0);
                    update_option('mo_share_options_enable_static_pages', isset($_POST['mo_share_options_static_pages']) ? sanitize_text_field($_POST['mo_share_options_static_pages']) : 0);
                    update_option('mo_share_options_wc_sp_summary', isset($_POST['mo_share_options_wc_sp_summary']) ? sanitize_text_field($_POST['mo_share_options_wc_sp_summary']) : 0);
                    update_option('mo_share_options_wc_sp_summary_top', isset($_POST['mo_share_options_wc_sp_summary_top']) ? sanitize_text_field($_POST['mo_share_options_wc_sp_summary_top']) : 0);
                    update_option('mo_share_options_enable_post_position', isset($_POST['mo_share_options_enable_post_position'])? sanitize_text_field($_POST['mo_share_options_enable_post_position']):0);
                    update_option('mo_share_options_home_page_position',isset($_POST['mo_share_options_home_page_position'])? sanitize_text_field($_POST['mo_share_options_home_page_position']):0);
                    update_option('mo_share_options_static_pages_position',isset($_POST['mo_share_options_static_pages_position'])? sanitize_text_field($_POST['mo_share_options_static_pages_position']):0);
                    update_option('mo_share_options_bb_forum_position',isset($_POST['mo_share_options_bb_forum_position'])? sanitize_text_field($_POST['mo_share_options_bb_forum_position']):0);
                    update_option('mo_share_options_bb_topic_position',isset($_POST['mo_share_options_bb_topic_position'])? sanitize_text_field($_POST['mo_share_options_bb_topic_position']):0);
                    update_option('mo_share_options_bb_reply_position',isset($_POST['mo_share_options_bb_reply_position'])? sanitize_text_field($_POST['mo_share_options_bb_reply_position']):0);
                    update_option('mo_share_vertical_hide_mobile', isset($_POST['mo_share_vertical_hide_mobile']) ? sanitize_text_field($_POST['mo_share_vertical_hide_mobile']) : 0);
                    update_option('mo_share_options_bb_forum', isset($_POST['mo_share_options_bb_forum']) ? sanitize_text_field($_POST['mo_share_options_bb_forum']) : 0);
                    update_option('mo_share_options_bb_topic', isset($_POST['mo_share_options_bb_topic']) ? sanitize_text_field($_POST['mo_share_options_bb_topic']) : 0);
                    update_option('mo_share_options_bb_reply', isset($_POST['mo_share_options_bb_reply']) ? sanitize_text_field($_POST['mo_share_options_bb_reply']) : 0);
	                update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_share_cnt':
                $nonce=$_POST['mo_openid_share_cnt_nonce'];
                if (!wp_verify_nonce($nonce, 'mo-openid-share-cnt-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                }else {
                    update_option( 'mo_openid_share_count', isset( $_POST['mo_openid_share_count']) ? sanitize_text_field($_POST['mo_openid_share_count']) : 0);
                    update_option( 'mo_openid_Facebook_share_count_api', isset( $_POST['mo_openid_Facebook_share_count_api']) ? sanitize_text_field($_POST['mo_openid_Facebook_share_count_api']) : '');
	                update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_comment_selectapp':
                $nonce = $_POST['mo_openid_enable_comment_selectapp_nonce'];
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-comment-selectapp-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                } else {
                    update_option('mo_openid_social_comment_fb', isset($_POST['mo_openid_social_comment_fb']) ? sanitize_text_field($_POST['mo_openid_social_comment_fb']) : 0);
                    update_option('mo_openid_social_comment_disqus', isset($_POST['mo_openid_social_comment_disqus']) ? sanitize_text_field($_POST['mo_openid_social_comment_disqus']) : 0);
                    update_option('mo_openid_social_comment_default', isset($_POST['mo_openid_social_comment_default']) ? sanitize_text_field($_POST['mo_openid_social_comment_default']) : 0);
                    update_option('mo_disqus_shortname', isset($_POST['mo_disqus_shortname']) ? sanitize_text_field($_POST['mo_disqus_shortname']) : "");
	                update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_comment_display':
                $nonce = $_POST['mo_openid_enable_comment_display_nonce'];
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-comment-display-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                } else {
                    update_option('mo_openid_social_comment_blogpost', isset($_POST['mo_openid_social_comment_blogpost']) ? sanitize_text_field($_POST['mo_openid_social_comment_blogpost']) : 0);
                    update_option('mo_openid_social_comment_static', isset($_POST['mo_openid_social_comment_static']) ? sanitize_text_field($_POST['mo_openid_social_comment_static']) : 0);
	                update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;

            case 'mo_openid_comment_labels':
                $nonce = $_POST['mo_openid_enable_comment_labels_nonce'];
                if (!wp_verify_nonce($nonce, 'mo-openid-enable-comment-labels-nonce')) {
                    wp_die('<strong>ERROR</strong>: Invalid Request.');
                } else {
                    update_option('mo_openid_social_comment_default_label',isset($_POST['mo_openid_social_comment_default_label'])? sanitize_text_field($_POST['mo_openid_social_comment_default_label']):0);
                    update_option('mo_openid_social_comment_fb_label', isset($_POST['mo_openid_social_comment_fb_label'])?sanitize_text_field($_POST['mo_openid_social_comment_fb_label']):0);
                    update_option('mo_openid_social_comment_disqus_label', isset($_POST['mo_openid_social_comment_disqus_label'])?sanitize_text_field($_POST['mo_openid_social_comment_disqus_label']):0);
                    update_option('mo_openid_social_comment_heading_label',isset($_POST['mo_openid_social_comment_heading_label'])? sanitize_text_field($_POST['mo_openid_social_comment_heading_label']):0);
	                update_option('mo_openid_message', 'Your settings are saved successfully.');
	                mo_wc_openid_show_success_message();
                }
                break;
        }
    }

    public function mo_wc_get_output( $atts ){
            $miniorange_widget = new mo_wc_openid_login_wid();
            $html = $miniorange_widget->mo_wc_openidloginFormShortCode( $atts );
            return $html;
    }
    function mo_wc_openid_deactivate() {

        delete_option('mo_openid_host_name');
        delete_option( 'mo_openid_facebook_enable');
        delete_option( 'mo_openid_google_enable');
        delete_option( 'mo_openid_vkontakte_enable');
        delete_option( 'mo_openid_twitter_enable');
        delete_option( 'mo_openid_amazon_enable');
        delete_option( 'mo_openid_linkedin_enable');
        delete_option( 'mo_openid_instagram_enable');
        delete_option( 'mo_openid_windowslive_enable');
        delete_option( 'mo_openid_yahoo_enable');
    }

    function mo_wc_openid_add_social_share_links($content) {
        global $post;
        $post_content=$content;
        $title = str_replace('+', '%20', urlencode($post->post_title));

        if(is_front_page() && get_option('mo_share_options_enable_home_page')==1){
            $html_content = mo_wc_openid_share_shortcode('', $title);

            if ( get_option('mo_share_options_home_page_position') == 'before' ) {
                return  $html_content . $post_content;
            } else if ( get_option('mo_share_options_home_page_position') == 'after' ) {
                return   $post_content . $html_content;
            } else if ( get_option('mo_share_options_home_page_position') == 'both' ) {
                return $html_content . $post_content . $html_content;
            }
        } else if(is_page() && get_option('mo_share_options_enable_static_pages')==1){
            $html_content = mo_wc_openid_share_shortcode('', $title);

            if ( get_option('mo_share_options_static_pages_position') == 'before' ) {
                return  $html_content . $post_content;
            } else if ( get_option('mo_share_options_static_pages_position') == 'after' ) {
                return   $post_content . $html_content;
            } else if ( get_option('mo_share_options_static_pages_position') == 'both' ) {
                return $html_content . $post_content . $html_content;
            }
        } else if(is_single() && get_option('mo_share_options_enable_post') == 1 ){
            $html_content = mo_wc_openid_share_shortcode('', $title);

            if ( get_option('mo_share_options_enable_post_position') == 'before' ) {
                return  $html_content . $post_content;
            } else if ( get_option('mo_share_options_enable_post_position') == 'after' ) {
                return   $post_content . $html_content;
            } else if ( get_option('mo_share_options_enable_post_position') == 'both' ) {
                return $html_content . $post_content . $html_content;
            }
        } else
            return $post_content;

    }

    function mo_wc_social_login_custom_avatar( $avatar, $mixed, $size, $default, $alt = '' ) {

        if ( is_numeric( $mixed ) AND $mixed > 0 ) {	//Check if we have a user identifier
            $user_id = $mixed;
        } elseif ( is_string( $mixed ) AND ( $user = get_user_by( 'email', $mixed )) ) {	//Check if we have a user email
            $user_id = $user->ID;
        } elseif ( is_object( $mixed ) AND property_exists( $mixed, 'user_id' ) AND is_numeric( $mixed->user_id ) ) {		//Check if we have a user object
            $user_id = $mixed->user_id;
        } else {		//None found
            $user_id = null;
        }

        if (  !empty( $user_id ) ) {    //User found?
            $filename = '';
            if (!(is_dir($filename))) {
                $user_meta_thumbnail = get_user_meta($user_id, 'moopenid_user_avatar', true);        //Read the avatar
                $user_meta_name = get_user_meta($user_id, 'user_name', true);        //read user details
                $user_picture = (!empty($user_meta_thumbnail) ? $user_meta_thumbnail : '');
                if ($user_picture !== false AND strlen(trim($user_picture)) > 0) {    //Avatar found?
                    return '<img alt="' . $user_meta_name . '" src="' . $user_picture . '" class="avatar apsl-avatar-social-login avatar-' . $size . ' photo" height="' . $size . '" width="' . $size . '" />';
                }
            }
        }
        return $avatar;
    }

    function mo_wc_social_login_custom_avatar_url( $url, $id_or_email, $args = null ) {
        if ( is_numeric( $id_or_email ) AND $id_or_email > 0 ) {	//Check if we have an user identifier
            $user_id = $id_or_email;
        } elseif ( is_string( $id_or_email ) AND ( $user = get_user_by( 'email', $id_or_email )) ) {	//Check if we have an user email
            $user_id = $user->ID;
        } elseif ( is_object( $id_or_email ) AND property_exists( $id_or_email, 'user_id' ) AND is_numeric( $id_or_email->user_id ) ) {		//Check if we have an user object
            $user_id = $id_or_email->user_id;
        } else {		//None found
            $user_id = null;
        }

        if (  !empty( $user_id ) ) {
            $filename = '';
            if (!(is_dir($filename))) {
                $user_meta_thumbnail = get_user_meta($user_id, 'moopenid_user_avatar', true);
                $user_picture = (!empty($user_meta_thumbnail) ? $user_meta_thumbnail : $url);
                return $user_picture;
            }
        }
        return $url;
    }

    public function mo_wc_get_sharing_output( $atts ){
        $title = '';
        global $post;
        if(isset($post)) {
            $content=get_the_content();
            $title = str_replace('+', '%20', urlencode($post->post_title));
            $content=strip_shortcodes( strip_tags( get_the_content() ) );
        }
        $html = mo_wc_openid_share_shortcode( $atts, $title);
        return $html;
    }

    public function mo_wc_get_vertical_sharing_output( $atts )
    {
        $title = '';
        global $post;
        if (isset($post)) {
            $content = get_the_content();
            $title = str_replace('+', '%20', urlencode($post->post_title));
            $content = strip_shortcodes(strip_tags(get_the_content()));
        }
        $html = mo_wc_openid_vertical_share_shortcode($atts, $title);
        return $html;
    }
    public function mo_wc_get_comments_output( $atts ){
        $html = mo_wc_openid_comments_shortcode();
        return $html;
    }
}


new mo_wc_openid_sso_settings();