<?php
require 'social_apps/mo_openid_configured_apps_funct.php';

function mo_wc_openid_start_session() {
    if( !session_id() ) {
        session_start();
    }
}

function mo_wc_openid_end_session() {
    session_start();
    session_unset(); //unsets all session variables
}

function mo_wc_openid_custom_app_oauth_redirect($appname){
    if(isset($_REQUEST['test']))
        setcookie("mo_oauth_test", true);
    else
        setcookie("mo_oauth_test", false);
    if($appname=='yaahoo'){
        $appname='yahoo';
    }
    require('social_apps/' . $appname . '.php');
    $social_app = new $appname();
    $social_app->mo_wc_openid_get_app_code();
}

function mo_wc_openid_process_custom_app_callback()
{
    $appname = "";

    if (is_user_logged_in() && get_option('mo_openid_test_configuration') != 1) {
        return;
    }
    $code = $profile_url = $client_id = $current_url = $client_secret = $access_token_uri = $postData = $oauth_token = $user_url = $user_name = $email = '';
    $oauth_access_token = $redirect_url = $option = $oauth_token_secret = $screen_name = $profile_json_output = $oauth_verifier = $twitter_oauth_token = $access_token_json_output = [];
    mo_wc_openid_start_session();
    if (strpos($_SERVER['REQUEST_URI'], "oauth_verifier") !== false) {
        $_SESSION['appname'] = "twitter";
    }

    if (isset($_SESSION['appname'])) {
        $appname = $_SESSION['appname'];
    } else if (strpos($_SERVER['REQUEST_URI'], "openidcallback") !== false) {
        if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/google") !== false) || (strpos($_SERVER['REQUEST_URI'], "openidcallback=google") !== false)) {
            $appname = "google";
        } else if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/facebook") !== false) || (strpos($_SERVER['REQUEST_URI'], "openidcallback=facebook") !== false)) {
            $appname = "facebook";
        } else if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/windowslive") !== false)) {
            $appname = "windowslive";
        } else if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/vkontakte") !== false)) {
            $appname = "vkontakte";
        } else if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/linkedin") !== false)) {
            $appname = "linkedin";
        } else if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/instagram") !== false) || (strpos($_SERVER['REQUEST_URI'], "openidcallback=instagram") !== false)) {
            $appname = "instagram";
        } else if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/amazon") !== false) || (strpos($_SERVER['REQUEST_URI'], "openidcallback=amazon") !== false)) {
            $appname = "amazon";
        } else if ((strpos($_SERVER['REQUEST_URI'], "openidcallback/yahoo") !== false) || (strpos($_SERVER['REQUEST_URI'], "openidcallback=yaahoo") !== false)) {
            $appname = "yahoo";
        }
    } else {
        return;
    }
     if($appname=='yaahoo'){
         $appname='yahoo';
     }
    require('social_apps/' . $appname . '.php');
    $social_app = new $appname();
    $appuserdetails = $social_app->mo_wc_openid_get_access_token();
    mo_wc_openid_process_user_details($appuserdetails,$appname);
}

function mo_wc_openid_process_user_details($appuserdetails,$appname)
{
    $first_name = $last_name = $email = $user_name = $user_url = $user_picture = $social_user_id = $full_name = '';
    $location_city = $location_country = $about_me = $company_name = $age = $gender = $birth_date = $friend_nos = $website = $field_of_study = $university_name = $places_lived = $position = $relationship = $contact_no = $industry = $head_line = $NA = '';

    $first_name = isset($appuserdetails['first_name'])?$appuserdetails['first_name']:'';
    $last_name = isset($appuserdetails['last_name'])?$appuserdetails['last_name']:'';
    $email = isset($appuserdetails['email'])?$appuserdetails['email']:'';
    $user_name = isset($appuserdetails['user_name'])?$appuserdetails['user_name']:'';
    $user_url = isset($appuserdetails['user_url'])?$appuserdetails['user_url']:'';
    $user_picture = isset($appuserdetails['user_picture'])?$appuserdetails['user_picture']:'';
    $social_user_id = isset($appuserdetails['social_user_id'])?$appuserdetails['social_user_id']:'';
    $full_name = isset($appuserdetails['full_name'])?$appuserdetails['full_name']:'';
    $location_city = isset($appuserdetails['location_city'])?$appuserdetails['location_city']:'';
    $location_country = isset($appuserdetails['location_country'])?$appuserdetails['location_country']:'';
    $about_me = isset($appuserdetails['about_me'])?$appuserdetails['about_me']:'';
    $company_name = isset($appuserdetails['company_name'])?$appuserdetails['company_name']:'';
    $age = isset($appuserdetails['age'])?$appuserdetails['age']:'';
    $gender = isset($appuserdetails['gender'])?$appuserdetails['gender']:'';
    $birth_date = isset($appuserdetails['birth_date'])?$appuserdetails['birth_date']:'';
    $friend_nos = isset($appuserdetails['friend_nos'])?$appuserdetails['friend_nos']:'';
    $website = isset($appuserdetails['website'])?$appuserdetails['website']:'';
    $field_of_study = isset($appuserdetails['field_of_study'])?$appuserdetails['field_of_study']:'';
    $university_name = isset($appuserdetails['university_name'])?$appuserdetails['university_name']:'';
    $places_lived = isset($appuserdetails['places_lived'])?$appuserdetails['places_lived']:'';
    $position = isset($appuserdetails['position'])?$appuserdetails['position']:'';
    $relationship = isset($appuserdetails['relationship'])?$appuserdetails['relationship']:'';
    $contact_no = isset($appuserdetails['contact_no'])?$appuserdetails['contact_no']:'';
    $industry = isset($appuserdetails['industry'])?$appuserdetails['industry']:'';
    $head_line = isset($appuserdetails['head_line'])?$appuserdetails['head_line']:'';

    $user_name = str_replace(' ', '-', $user_name);
    $user_name = sanitize_user($user_name, true);

    if ($user_name == '-' || $user_name == '') {
        $splitemail = explode('@', $email);
        $user_name = $splitemail[0];
    }

    //Set User Full Name
    if (isset($first_name) && isset($last_name)) {
        if (strcmp($first_name, $last_name) != 0)
            $user_full_name = $first_name . ' ' . $last_name;
        else
            $user_full_name = $first_name;
    }
    else if(isset($first_name))
        $user_full_name = $first_name;
    else {
        $user_full_name = $user_name;
        $first_name = '';
        $last_name = '';
    }

    //check_existing_user
    global $wpdb;
    $db_prefix = $wpdb->prefix;
    $linked_email_id = $wpdb->get_var($wpdb->prepare("SELECT user_id FROM " . $db_prefix . "mo_openid_linked_user where linked_social_app = \"%s\" AND identifier = %s", $appname, $social_user_id));

    $user_email = sanitize_email($email);

    $email_user_id = $wpdb->get_var($wpdb->prepare("SELECT user_id FROM " . $db_prefix . "mo_openid_linked_user where linked_email = \"%s\"", $user_email));

    if (empty($user_email)) {
        $existing_email_user_id = NULL;
    } else {
        $existing_email_user_id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->users where user_email = \"%s\"", $user_email));
    }

    $session_values= array(
        'username' => $user_name,
        'user_email' => $user_email,
        'user_full_name' => $user_full_name,
        'first_name' => $first_name,
        'last_name' => $last_name,
        'user_url' => $user_url,
        'user_picture' => $user_picture,
        'social_app_name' => $appname,
        'social_user_id' => $social_user_id,
    );
    mo_wc_openid_start_session_login($session_values);
    // user is a member
    if ((isset($linked_email_id)) || (isset($email_user_id)) || (isset($existing_email_user_id))) {
        if ((!isset($linked_email_id)) && (isset($email_user_id))) {
            $linked_email_id = $email_user_id;
            mo_wc_openid_insert_query($appname, $user_email, $linked_email_id, $social_user_id);
        }
        if (isset($linked_email_id)) {
            $user = get_user_by('id', $linked_email_id);
            $user_id = $user->ID;
        } else if (isset($email_user_id)) {
            $user = get_user_by('id', $email_user_id);
            $user_id = $user->ID;
        } else {
            $user = get_user_by('id', $existing_email_user_id);
            $user_id = $user->ID;
        }
        mo_wc_openid_login_user($user_id,$user,$user_picture);
    }
    //new user creation
    if(get_option('mo_openid_auto_register_enable')) {
            mo_wc_create_new_user($session_values);
    }else{
        mo_wc_openid_disabled_register_message();
    }
}

function mo_wc_create_new_user($user_val){
    $user_name = $user_val['username'];
    $email = $user_val['user_email'];
    $user_full_name = $user_val['user_full_name'];
    $first_name = $user_val['first_name'];
    $last_name = $user_val['last_name'];
    $user_url = $user_val['user_url'];
    $user_picture = $user_val['user_picture'];
    $appname = $user_val['social_app_name'];
    $social_user_id = $user_val['social_user_id'];
    global $wpdb;
    $db_prefix = $wpdb->prefix;
    $user_email = sanitize_email($email);
    if(empty($user_name) && !empty($email))
    {
        $split_email  = explode('@',$email);
        $user_name = $split_email[0];
        $user_email = $email;
    }
    else if(empty($email) && !empty($user_name))
    {
        $split_app_name = explode('_',$appname);
        $user_email = $user_name.'@'.$split_app_name[0].'.com';
    }
    else if(empty($email) && empty($user_name))
    {
        wp_die('No profile data is returned from application. Please contact your administrator.');
    }

    $user_email = str_replace(' ', '', $user_email);

    $random_password 	= wp_generate_password( 10, false );
    $user_profile_url  = $user_url;

    if(isset($appname) && !empty($appname) && $appname=='facebook'){
        $user_url = '';
    }

    // Checking if username already exist
    $user_name_user_id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->users where user_login = %s", $user_name));

    if( isset($user_name_user_id) ){
        $email_array = explode('@', $user_email);
        $user_name = $email_array[0];
        $user_name_user_id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->users where user_login = %s", $user_name));
        $i = 1;
        while(!empty($user_name_user_id) ){
            $uname=$user_name.'_' . $i;
            $user_name_user_id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM " .$db_prefix."users where user_login = %s", $uname));
            $i++;
            if(empty($user_name_user_id)){
                $user_name= $uname;
            }
        }

        if( isset($user_name_user_id) ){
            echo '<br/>'."Error Code Existing Username: ".get_option('mo_existing_username_error_message');
            exit();
        }
    }

    $userdata = array(
        'user_login'  =>  $user_name,
        'user_email'    =>  $user_email,
        'user_pass'   =>  $random_password,
        'display_name' => $user_full_name,
        'first_name' => $first_name,
        'last_name' => $last_name,
        'user_url' => $user_url,
    );
    $user_id 	= wp_insert_user( $userdata);

    if(is_wp_error( $user_id )) {
        print_r($user_id);
        wp_die("Error Code 5: ".get_option('mo_registration_error_message'));
    }

    update_option('mo_openid_user_count',get_option('mo_openid_user_count')+1);

    $session_values= array(
        'username' => $user_name,
        'user_email' => $user_email,
        'user_full_name' => $user_full_name,
        'first_name' => $first_name,
        'last_name' => $last_name,
        'user_url' => $user_url,
        'user_picture' => $user_picture,
        'social_app_name' => $appname,
        'social_user_id' => $social_user_id,
    );

    mo_wc_openid_start_session_login($session_values);
    $user	= get_user_by('id', $user_id );
    //registration hook
    do_action( 'mo_user_register', $user_id,$user_profile_url);
    mo_wc_openid_link_account($user->user_login, $user);
    mo_wc_openid_login_user($user_id,$user,$user_picture);
}

function mo_wc_openid_customize_logo(){
    $logo =" <div style='float:left;' class='mo_image_id'>
                <a target='_blank' href='https://www.miniorange.com/'>
                <img alt='logo' src='". plugins_url('/includes/images/miniOrange.png',__FILE__) ."' class='mo_openid_image'>
                </a>
                </div>
                <br/>";
    return $logo;
}

function mo_wc_openid_plugin_update(){
    global $wpdb;
    $table_name = $wpdb->prefix . 'mo_openid_linked_user';
    $charset_collate = $wpdb->get_charset_collate();

    $time = $wpdb->get_var("SELECT COLUMN_NAME 
                                    FROM information_schema.COLUMNS 
                                    WHERE
                                     TABLE_SCHEMA='$wpdb->dbname'
                                     AND COLUMN_NAME = 'timestamp'");

    $data_type=$wpdb->get_var("SELECT DATA_TYPE 
                    FROM information_schema.COLUMNS
                    WHERE
                    TABLE_SCHEMA='$wpdb->dbname'
                    AND TABLE_NAME = '$table_name'
                    AND COLUMN_NAME = 'user_id'");

    if($data_type=="mediumint")
    {
        $wpdb->get_var("ALTER TABLE $table_name CHANGE `user_id` `user_id` BIGINT(20) NOT NULL");

    }

    // if table mo_openid_linked_user doesn't exist or the 'timestamp' column doesn't exist
    if($wpdb->get_var("show tables like '$table_name'") != $table_name || empty($time) ) {
        $sql = "CREATE TABLE $table_name (
                    id mediumint(9) NOT NULL AUTO_INCREMENT,
                    linked_social_app varchar(55) NOT NULL,
                    linked_email varchar(55) NOT NULL,
                    user_id BIGINT(20) NOT NULL,
                    identifier VARCHAR(100) NOT NULL,
                    timestamp datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
                    PRIMARY KEY  (id)
                ) $charset_collate;";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);

        $identifier = $wpdb->get_var("SELECT COLUMN_NAME 
                                    FROM information_schema.COLUMNS 
                                    WHERE 
                                    TABLE_NAME = '$wpdb->users' 
                                    AND TABLE_SCHEMA='$wpdb->dbname'
                                    AND COLUMN_NAME = 'identifier'");

        if(strcasecmp( $identifier, "identifier") == 0 ){

            $count= $wpdb->get_var("SELECT count(ID) FROM $wpdb->users WHERE identifier not LIKE ''");
            $result= $wpdb->get_results("SELECT * FROM $wpdb->users WHERE identifier not LIKE ''");

            for($icnt = 0; $icnt < $count; $icnt = $icnt + 1){

                $provider = $result[$icnt]->provider;
                $split_app_name = explode('_', $provider);
                $provider = strtolower($split_app_name[0]);
                $user_email = $result[$icnt]->user_email;
                $ID = $result[$icnt]->ID;
                $identifier = $result[$icnt]->identifier;

                $output = $wpdb->insert(
                    $table_name,
                    array(
                        'linked_social_app' => $provider,
                        'linked_email' => $user_email,
                        'user_id' =>  $ID,
                        'identifier' => $identifier
                    ),
                    array(
                        '%s',
                        '%s',
                        '%d',
                        '%s'
                    )
                );
                if($output === false){
                    $wpdb->show_errors();
                    $wpdb->print_error();
                    wp_die('Error in insert Query');
                    exit;

                }

            }
            $wpdb->get_var("ALTER TABLE $wpdb->users DROP COLUMN provider");
            $wpdb->get_var("ALTER TABLE $wpdb->users DROP COLUMN identifier");
        }
    }

    $current_version = get_option('mo_wc_openid_social_login_version');

    if(!$current_version && version_compare(MO_WC_OPENID_SOCIAL_LOGIN_VERSION,"200.1.1",">=")){
        //delete entries from mo_openid_linked_user table which have empty column values
        $result = $wpdb->query(
            $wpdb->prepare(
                "
                        DELETE FROM {$table_name}
                        WHERE linked_social_app = %s
                        OR linked_email = %s
                        OR user_id = %d
                        OR identifier = %s
                        ",
                '','',0, ''
            )
        );
        if($result === false){
            /*$wpdb->show_errors();
            $wpdb->print_error();
            exit;*/
            wp_die('Error in deletion query');
        }
    }
    update_option('mo_wc_openid_social_login_version',MO_WC_OPENID_SOCIAL_LOGIN_VERSION);
}

function mo_wc_openid_delete_social_profile($id){
    // delete first name, last name, user_url and profile_url from usermeta
    global $wpdb;
    $metakey1 = 'first_name';
    $metakey2 = 'last_name';
    $metakey3 = 'moopenid_user_avatar';
    $metakey4 = 'moopenid_user_profile_url';
    $wpdb->query($wpdb->prepare('DELETE from '.$wpdb->prefix.'usermeta where user_id = %d and (meta_key = %s or meta_key = %s  or meta_key = %s  or meta_key = %s)',$id,$metakey1,$metakey2,$metakey3,$metakey4));
    update_user_meta($id,'mo_openid_data_deleted','1');
    exit;
}

function mo_wc_checkTimeStamp($sentTime,$validatedTime){
    $diff 		= round(abs($validatedTime - $sentTime) / 60,2);
    if($diff>5)
        return false;
    else
        return true;
}

function mo_wc_checkTransactionId($customerKey,$otpToken,$transactionId,$pass){
    if(!$pass){
        return false;
    }
    $stringToHash 	= $customerKey . $otpToken;
    $txtID 		= hash("sha512", $stringToHash);
    if($txtID == $transactionId)
        return true;
}


function mo_wc_openid_check_empty_or_null( $value ) {
    if( ! isset( $value ) || empty( $value ) ) {
        return true;
    }
    return false;
}

function mo_wc_openid_decrypt_sanitize($param) {
    if(strcmp($param,'null')!=0 && strcmp($param,'')!=0){
        $customer_token = get_option('mo_openid_customer_token');
        $decrypted_token = mo_wc_decrypt_data($param,$customer_token);
        // removes control characters and some blank characters
        $decrypted_token_sanitise = preg_replace('/[\x00-\x1F][\x7F][\x81][\x8D][\x8F][\x90][\x9D][\xA0][\xAD]/', '', $decrypted_token);
        //strips space,tab,newline,carriage return,NUL-byte,vertical tab.
        return trim($decrypted_token_sanitise);
    }else{
        return '';
    }
}

function mo_wc_decrypt_data($data, $key) {
    return openssl_decrypt( base64_decode($data), 'aes-128-ecb', $key, OPENSSL_RAW_DATA);
}

function mo_wc_openid_show_success_message() {
    remove_action( 'admin_notices', 'mo_wc_openid_success_message' );
    add_action( 'admin_notices', 'mo_wc_openid_error_message' );
}

function mo_wc_openid_show_error_message() {
    remove_action( 'admin_notices', 'mo_wc_openid_error_message' );
    add_action( 'admin_notices', 'mo_wc_openid_success_message');
}

function mo_wc_openid_success_message() {
    $message = get_option('mo_openid_message'); ?>
    <div id="snackbar"><?php echo($message);?></div>
    <style>
        #snackbar {
            visibility: hidden;
            min-width: 250px;
            margin-left: -125px;
            background-color: #c02f2f;
            color: #fff;
            text-align: center;
            border-radius: 2px;
            padding: 16px;
            position: fixed;
            z-index: 1;
            top: 8%;
            right: 30px;
            font-size: 17px;
        }

        #snackbar.show {
            visibility: visible;
            -webkit-animation: fadein 0.5s, fadeout 0.5s 3.5s;
            animation: fadein 0.5s, fadeout 0.5s 3.5s;
        }

        @-webkit-keyframes fadein {
            from {right: 0; opacity: 0;}
            to {right: 30px; opacity: 1;}
        }

        @keyframes fadein {
            from {right: 0; opacity: 0;}
            to {right: 30px; opacity: 1;}
        }

        @-webkit-keyframes fadeout {
            from {right: 30px; opacity: 1;}
            to {right: 0; opacity: 0;}
        }

        @keyframes fadeout {
            from {right: 30px; opacity: 1;}
            to {right: 0; opacity: 0;}
        }
    </style>
    <script>
        var x = document.getElementById("snackbar");
        x.className = "show";
        setTimeout(function(){ x.className = x.className.replace("show", ""); }, 4000);
    </script>
<?php }

function mo_wc_openid_error_message() {
    $message = get_option('mo_openid_message'); ?>
    <div id="snackbar"><?php echo($message);?></div>
    <style>
        #snackbar {
            visibility: hidden;
            min-width: 250px;
            margin-left: -125px;
            background-color: #4CAF50;
            color: #fff;
            text-align: center;
            border-radius: 2px;
            padding: 16px;
            position: fixed;
            z-index: 1;
            top: 8%;
            right: 30px;
            font-size: 17px;
        }

        #snackbar.show {
            visibility: visible;
            -webkit-animation: fadein 0.5s, fadeout 0.5s 3.5s;
            animation: fadein 0.5s, fadeout 0.5s 3.5s;
        }

        @-webkit-keyframes fadein {
            from {right: 0; opacity: 0;}
            to {right: 30px; opacity: 1;}
        }

        @keyframes fadein {
            from {right: 0; opacity: 0;}
            to {right: 30px; opacity: 1;}
        }

        @-webkit-keyframes fadeout {
            from {right: 30px; opacity: 1;}
            to {right: 0; opacity: 0;}
        }

        @keyframes fadeout {
            from {right: 30px; opacity: 1;}
            to {right: 0; opacity: 0;}
        }
    </style>
    <script>

        var x = document.getElementById("snackbar");
        x.className = "show";
        setTimeout(function(){ x.className = x.className.replace("show", ""); }, 4000);

    </script>
<?php }

function mo_wc_openid_share_action(){
    $nonce = $_POST['mo_openid_share_nonce'];
    if (!wp_verify_nonce($nonce, 'mo-openid-share')) {
        wp_die('<strong>ERROR</strong>: Invalid Request.');
    } else {
        $enable_id = sanitize_text_field($_POST['enabled']);
        if ($enable_id == "true") {
            update_option(sanitize_text_field($_POST['id_name'], 1));
        } else if ($enable_id == "false") {
            update_option(sanitize_text_field($_POST['id_name'], 0));
        }
    }
}

function mo_wc_sharing_app_value()
{
    $return_apps='';
    $count=1;
    foreach ($_POST['app_name'] as $app) {
        $app_value = get_option('mo_openid_' . $app . '_share_enable');
        if($app_value) {
            if($count==1) {
                $return_apps = $app;
                $count++;
            }
            else
                $return_apps.="#".$app;
        }
    }
    wp_send_json($return_apps);

}

function mo_wc_openid_activation_message() {
    $class = "updated";
    $message = get_option('mo_openid_message');
    echo "<div class='" . $class . "'> <p>" . $message . "</p></div>";
}

function mo_wc_openid_add_custom_column1($columns){
    $columns['mo_openid_delete_profile_data'] = 'Delete Social Profile Data';
    return $columns;
}

function mo_wc_openid_delete_social_profile_script(){
    ?>
    <script type="text/javascript">
        function moOpenidDeleteSocialProfile(elem, userId){
            jQuery.ajax({
                url:"<?php echo admin_url();?>", //the page containing php script
                method: "POST", //request type,
                data: {action : 'delete_social_profile_data', user_id : userId},
                dataType: 'text',
                success:function(result){
                    alert('Social Profile Data Deleted successfully. Press OK to continue.');
                    window.location.reload(true);
                }
            });
        }
        function copyToClipboard(copyButton, element, copyelement) {
            var temp = jQuery("<input>");
            jQuery("body").append(temp);
            temp.val(jQuery(element).text()).select();
            document.execCommand("copy");
            temp.remove();
            jQuery(copyelement).text("Copied");
            jQuery(copyButton).mouseout(function(){
                jQuery(copyelement).text("Copy to Clipboard");
            });
        }
    </script>
    <?php
}