<?php
function mo_wc_openid_validate_code()
{
    if (isset($_REQUEST['code'])) {
        $code = sanitize_text_field($_REQUEST['code']);
        return $code;
    } // this handles incorrect scope(only for linkedin).
    else if (array_key_exists('error', $_REQUEST)) {
        if (is_user_logged_in() && get_option('mo_openid_test_configuration') == 1) {
            update_option('mo_openid_test_configuration', 0);
            echo '<div style="color: #a94442;background-color: #f2dede;padding: 15px;margin-bottom: 20px;text-align:center;border:1px solid #E6B3B2;font-size:18pt;">TEST FAILED</div>
						<div style="color: #a94442;font-size:14pt; margin-bottom:20px;">WARNING: Please enter correct scope value and try again. <br/>';
            print_r(esc_attr($_REQUEST));
            echo '</div>
						<div style="display:block;text-align:center;margin-bottom:4%;"><img style="width:15%;"src="' . plugin_dir_url(__FILE__) . '/includes/images/wrong.png"></div>';
            exit;
        } else {
            echo esc_attr($_REQUEST['error_description']) . "<br>";
            wp_die("Allow access to your profile to get logged in. Click <a href=" . get_site_url() . ">here</a> to go back to the website.");
            exit;
        }
    }
}

function mo_wc_get_permalink($appname)
{
    $value = get_option('siteurl');
    $apps2_list = array("line","dribbble","discord","stack","flickr","apple","tumblr","spotify","meetup");
    $appsConfig=0;
    foreach($apps2_list as $key){
        if($appname==$key){
            $appsConfig=1;
            break;
        }
    }
    if (get_option('mo_openid_malform_error')||$appsConfig=='1') {
        if (get_option('permalink_structure')) {
            return $value . '/openidcallback/' . $appname;
        }
        else
            if($appname=="linkedin"){
                return $value . '/?openidcallback/' . $appname;
            }
        if($appname=="windowslive"||$appname=="vkontakte")
        {
            return $value;
        }
        else {
            return $value . '/?openidcallback=' . $appname;
        }
    }

    else {
        if (get_option('permalink_structure')) {
            return $value . '/openidcallback';
        } else
            return $value . '/?openidcallback';
    }
}

function wc_get_social_app_redirect_uri($appname){
    $apps2_list = array("line","dribbble","discord","stack","flickr","apple","tumblr","spotify","meetup");
    $appsConfig=0;
    foreach($apps2_list as $key ){
        if($appname==$key){
            $appsConfig=1;
            break;
        }

    }
    if(get_option('mo_openid_malform_error')||$appsConfig=='1'){
        if(get_option( 'permalink_structure' )) {
            $social_app_redirect_uri = site_url() .'/openidcallback/'.$appname;
        }
        else{
            if($appname=="windowslive"||$appname=="vkontakte")
            {
                $social_app_redirect_uri = site_url();
            }
            else {
                $social_app_redirect_uri = site_url() . '/?openidcallback=' . $appname;
            }
            if($appname=="linkedin"){
                $social_app_redirect_uri = site_url() . '/?openidcallback/' . $appname;
            }
        }
    }
    else{
        if(get_option( 'permalink_structure' )) {
            $social_app_redirect_uri = site_url() . '/openidcallback';
        }
        else{
            if($appname=="windowslive"||$appname=="vkontakte")
            {
                $social_app_redirect_uri = site_url();
            }
            else {
                $social_app_redirect_uri = site_url() .'/?openidcallback';
            }
        }
    }
    return $social_app_redirect_uri;
}
function mo_wc_openid_get_access_token($postData,$access_token_uri,$appname){
    $headers = '';
    if($appname == "google" || $appname== "spotify" || $appname == "apple")
    {
        $headers = array("Content-Type"=>"application/x-www-form-urlencoded");
    }
    $args = array(
        'method' => 'POST',
        'body' => $postData,
        'timeout' => '5',
        'redirection' => '5',
        'httpversion' => '1.0',
        'blocking' => true,
        'headers' => $headers
    );
    $result = wp_remote_post($access_token_uri, $args);
    if (is_wp_error($result)) {
        update_option('mo_openid_test_configuration', 0);
        echo $result['body'];
        exit();
    }
    $access_token_json_output = json_decode($result['body'], true);
    // this handles incorrect client secret for all apps.
    if ((array_key_exists('error', $access_token_json_output)) || array_key_exists('error_message', $access_token_json_output)) {
        if (is_user_logged_in() && get_option('mo_openid_test_configuration') == 1) {
            update_option('mo_openid_test_configuration', 0);
            //Test configuration failed window.

            echo '<div style="color: #a94442;background-color: #f2dede;padding: 15px;margin-bottom: 20px;text-align:center;border:1px solid #E6B3B2;font-size:18pt;">TEST FAILED</div>
                    <div style="color: #a94442;font-size:14pt; margin-bottom:20px;">WARNING: Client secret is incorrect for this app. Please check the client secret and try again.<br/>';
            print_r($access_token_json_output);
            echo '</div>
                    <div style="display:block;text-align:center;margin-bottom:4%;"><img style="width:15%;"src="' . plugin_dir_url(__FILE__) . '/includes/images/wrong.png"></div>';
            exit;
        }
    }
    return $access_token_json_output;
}

function mo_wc_openid_get_social_app_data($access_token,$profile_url,$app_name){
    $headers='';
    if($app_name != 'windowslive' && $app_name!= 'spotify' && $app_name!='meetup')
        $headers = ('Authorization:Bearer '.$access_token);
    $args = array(
        'timeout' => 120,
        'redirection' => 5,
        'httpversion' => '1.1',
        'headers' => $headers
    );

    $result = wp_remote_get($profile_url,$args);
    if(is_wp_error($result)){
        update_option( 'mo_openid_test_configuration', 0);
        echo $result['body'];
        exit();
    }
    $profile_json_output = json_decode($result['body'], true);
    return $profile_json_output;
}

function mo_wc_openid_app_test_config($profile_json_output){
    update_option( 'mo_openid_test_configuration', 0);
    $print = '<div style="color: #3c763d;
        background-color: #dff0d8; padding:2%;margin-bottom:20px;text-align:center; border:1px solid #AEDB9A; font-size:18pt;">TEST SUCCESSFUL</div>
        <div style="display:block;text-align:center;margin-bottom:1%;"><img style="width:15%;"src="'. plugin_dir_url(dirname(__FILE__)) . '/includes/images/green_check.png"></div>';
    $print .= mo_wc_openid_json_to_htmltable($profile_json_output);
    echo $print;
    exit;
}

function mo_wc_openid_json_to_htmltable($arr) {
    $str = "<table border='1'><tbody>";
    foreach ($arr as $key => $val) {
        $str .= "<tr>";
        $str .= "<td>$key</td>";
        $str .= "<td>";
        if (is_array($val)) {
            if (!empty($val)) {
                $str .= mo_wc_openid_json_to_htmltable($val);
            }
        } else {
            $str .= "<strong>$val</strong>";
        }
        $str .= "</td></tr>";
    }
    $str .= "</tbody></table>";

    return $str;
}

function mo_wc_openid_get_wp_style(){
    $path = site_url();
    $path .= '/wp-admin/load-styles.php?c=1&amp;dir=ltr&amp;load%5B%5D=dashicons,buttons,forms,l10n,login&amp;';
    return $path;
}

function mo_wc_openid_insert_query($social_app_name,$user_email,$userid,$social_app_identifier){
    // check if none of the column values are empty
    if(!empty($social_app_name) && !empty($user_email) && !empty($userid) && !empty($social_app_identifier)){
        date_default_timezone_set('Asia/Kolkata');
        $date = date('Y-m-d H:i:s');

        global $wpdb;
        $db_prefix = $wpdb->prefix;
        $table_name = $db_prefix. 'mo_openid_linked_user';

        $result = $wpdb->insert(
            $table_name,
            array(
                'linked_social_app' => $social_app_name,
                'linked_email' => $user_email,
                'user_id' =>  $userid,
                'identifier' => $social_app_identifier,
                'timestamp' => $date,
            ),
            array(
                '%s',
                '%s',
                '%d',
                '%s',
                '%s'
            )
        );
        if($result === false){
            /*                $wpdb->show_errors();
                            $wpdb->print_error();
                            exit;*/
            wp_die('Error in insert query');
        }
    }
}

function mo_wc_openid_start_session_login($session_values){
    mo_wc_openid_start_session();
    $_SESSION['mo_login'] = true;
    $_SESSION['registered_user']='1';
    $_SESSION['username'] = isset($session_values['username']) ? $session_values['username'] : '';
    $_SESSION['user_email'] = isset($session_values['user_email']) ? $session_values['user_email'] : '';
    $_SESSION['user_full_name'] = isset($session_values['user_full_name']) ? $session_values['user_full_name'] : '';
    $_SESSION['first_name'] = isset($session_values['first_name']) ? $session_values['first_name'] : '';
    $_SESSION['last_name'] = isset($session_values['last_name']) ? $session_values['last_name'] : '';
    $_SESSION['user_url'] = isset($session_values['user_url']) ? $session_values['user_url'] : '';
    $_SESSION['user_picture'] = isset($session_values['user_picture']) ? $session_values['user_picture'] : '';
    $_SESSION['social_app_name'] = isset($session_values['social_app_name']) ? $session_values['social_app_name'] : '';
    $_SESSION['social_user_id'] = isset($session_values['social_user_id']) ? $session_values['social_user_id'] : '';
}
function mo_wc_openid_login_user($user_id,$user,$user_picture){
    if (get_option('moopenid_social_login_avatar') && isset($user_picture))
        update_user_meta($user_id, 'moopenid_user_avatar', $user_picture);
    do_action('wp_login', $user->user_login, $user);
    exit;
}

//delete rows from account linking table that correspond to deleted user
function mo_wc_openid_delete_account_linking_rows($user_id){
    global $wpdb;
    $db_prefix = $wpdb->prefix;
    $result = $wpdb->get_var($wpdb->prepare("DELETE from ".$db_prefix."mo_openid_linked_user where user_id = %s ",$user_id));
    if($result === false){
        wp_die(get_option('mo_delete_user_error_message'));
    }
}