<?php
//to save positions of apps in DB
function mo_wc_openid_sso_sort_action(){

    $nonce = sanitize_text_field($_POST['mo_openid_sso_sort_nonce']);
    if (!wp_verify_nonce($nonce, 'mo-openid-sso-sort')) {
        wp_die('<strong>ERROR</strong>: Invalid Request.');
    } else {

        $app_sequence=array_map( 'sanitize_text_field', $_POST['sequence']);
        $app_pos='';
        $flag=0;
        foreach ($app_sequence as $app_position) {
            if($flag==0){
                $app_pos=$app_position;
                $flag++;
            }
            else
                $app_pos.='#'.$app_position;
        }
        update_option('app_pos',$app_pos);
        wp_send_json("hello_sort");
    }
}

//To enable and disable apps
function mo_wc_openid_sso_enable_app()
{
    $nonce = sanitize_text_field($_POST['mo_openid_sso_enable_app_nonce']);
    if (!wp_verify_nonce($nonce, 'mo-openid-sso-enable-app')) {
        wp_die('<strong>ERROR</strong>: Invalid Request.');
    } else {
        $enable_app = sanitize_text_field($_POST['enabled']);
        $wc_enable_app=sanitize_text_field($_POST['appname']);
        if ($enable_app == "true") {
            update_option('mo_openid_' . $wc_enable_app . '_enable', 1);
        } else if ($enable_app == "false") {
            update_option('mo_openid_' . $wc_enable_app . '_enable', 0);
        }
    }
}

//to load instructions of custom app
function mo_wc_openid_app_instructions_action()
{
    $nonce = sanitize_text_field($_POST['mo_openid_app_instructions_nonce']);
    if (!wp_verify_nonce($nonce, 'mo-openid-app-instructions')) {
        wp_die('<strong>ERROR</strong>: Invalid Request.');
    } else {
        $social_app = sanitize_text_field($_POST['app_name']);
        $instructions = mo_wc_plugin_url . $social_app . ".png##";
        $appslist = maybe_unserialize(get_option('mo_openid_apps_list'));
        if ($appslist != "") {
            if(!isset($appslist[$social_app]['clientid']))
                $instructions.="##";
            else
                $instructions .= $appslist[$social_app]['clientid'] . "##";
            if(!isset($appslist[$social_app]['clientsecret']))
                $instructions.="##";
            else
                $instructions .= $appslist[$social_app]['clientsecret'] . "##";
        } else
            $instructions .= "####";
        $name=plugin_dir_path(dirname(__DIR__));
        $name=substr($name,0,strlen($name)-1).'//social_apps//'.$social_app.'.php';
        require($name);
        $social_app = new $social_app();
        if(!isset($appslist[sanitize_text_field($_POST['app_name'])]['scope']))
            $instructions .= $social_app->scope . "##";
        else
            $instructions .= $appslist[sanitize_text_field($_POST['app_name'])]['scope'] . "##";
        if(isset($social_app->video_url))
            $instructions .= $social_app->video_url . "##";
        else
            $instructions .= "##";
        $instructions .= $social_app->instructions;
        wp_send_json($instructions);
    }
}

function mo_wc_openid_capp_details_action()
{
    $nonce = sanitize_text_field($_POST['mo_openid_capp_details_nonce']);
    if (!wp_verify_nonce($nonce, 'mo-openid-capp-details')) {
        wp_die('<strong>ERROR</strong>: Invalid Request.');
    } else {
        $clientid = stripslashes(sanitize_text_field($_POST['app_id']));
        $clientsecret = stripslashes(sanitize_text_field($_POST['app_secret']));
        $scope = stripslashes(sanitize_text_field($_POST['app_scope']));
        $appname = stripslashes(sanitize_text_field($_POST['app_name']));
        if (get_option('mo_openid_apps_list'))
            $appslist = maybe_unserialize(get_option('mo_openid_apps_list'));
        else
            $appslist = array();
        $newapp = array();
        foreach ($appslist as $key => $currentapp) {
            if ($appname == $key) {
                $newapp = $currentapp;
                break;
            }
        }
        $newapp['clientid'] = $clientid;
        $newapp['clientsecret'] = $clientsecret;
        $newapp['scope'] = $scope;
        if ($appname == "facebook") {
            $newapp['resolution'] = get_option('facebook_profile_pic_resolution');
        }
        $appslist[$appname] = $newapp;
        update_option('mo_openid_apps_list', maybe_serialize($appslist));
        update_option('mo_openid_enable_custom_app_'.$appname, '1');
        update_option('mo_openid_' . $appname . '_enable', 1);
    }
}

function mo_wc_openid_capp_delete(){
    $appname = stripslashes(sanitize_text_field($_POST['app_name']));
    $appslist = maybe_unserialize(get_option('mo_openid_apps_list'));
    $status= get_option('mo_openid_enable_custom_app_'.$appname);
    foreach($appslist as $key => $app){
        if($appname == $key){
            unset($appslist[$key]);
        }
    }
    if(!empty($appslist))
        update_option('mo_openid_apps_list', maybe_serialize($appslist));
    else
        delete_option('mo_openid_apps_list');
    update_option('mo_openid_enable_custom_app_'.$appname,'0');
    wp_send_json(["status" => $status]);
}

function mo_wc_disable_app(){
    $appname = sanitize_text_field($_POST['app_name']);
    update_option('mo_openid_enable_custom_app_'.$appname,0);
    update_option('mo_openid_'.$appname.'_enable',0);
}

function mo_wc_openid_test_configuration_update_action(){
    update_option('mo_openid_test_configuration',1);
}

function mo_wc_attribute_url(){
    $url = home_url();
    return $url;
}

function mo_wc_openid_check_capp_enable(){
    if (get_option('mo_openid_apps_list')){
        $appslist = maybe_unserialize(get_option('mo_openid_apps_list'));
        $appname = stripslashes(sanitize_text_field($_POST['app_name']));
        if(!empty($appslist[$appname]['clientid']) && !empty($appslist[$appname]['clientsecret'])){
            wp_send_json(["status"=>true]);
        }
        else
            wp_send_json(["status"=>false]);
    }
    else
        wp_send_json(["status"=>false]);
}